Index: trunk/Mars/resmc/hawcseye/transmission-pmma-3mm.txt
===================================================================
--- trunk/Mars/resmc/hawcseye/transmission-pmma-3mm.txt	(revision 19660)
+++ trunk/Mars/resmc/hawcseye/transmission-pmma-3mm.txt	(revision 19676)
@@ -1,71 +1,71 @@
-250.58364278170546 2.010118609808302
-252.49697751965863 6.434059596684008
-252.6188737031914 3.857934149112495
-252.7467558600228 9.342545080711972
-253.91402065322796 11.954353855061981
-254.24052828769095 15.55840448928889
-252.60799011537603 13.974426906972255
-254.5343851587076 19.23458362821991
-252.934497749839 17.57847754119919
-254.769470655521 23.040594075618287
-253.26100538430205 21.1825281754261
-255.0437370684699 26.760050317371764
-253.4569099649798 25.075092828469394
-255.0159839195406 30.281628091384547
-253.65281454565763 28.967657481512703
-255.31800348141883 33.93977510413956
-255.0894481372947 32.282006796434274
-255.84041569655966 37.111054710141886
-255.61186035243554 35.45328640243662
-256.7056609278865 40.60631893706818
-256.1342725675763 38.62456600843896
-257.0680844021404 43.91476143205719
-255.67716187932814 41.79703291493025
-257.63620768610605 46.9850611314738
-258.3953379362325 49.84967586243483
-258.7463336432802 53.183363334070286
-257.3750015785357 51.02235771412088
-259.50546389340667 56.04797806503131
-259.8760500585222 59.33838843384431
-258.4851275357098 57.220659916717366
-260.47682410593404 62.33655962855681
-261.1167790694815 65.24817661762441
-261.3828827915689 68.12059784930032
-262.1909891868648 70.66075303914181
-263.33703098382983 73.31944534154948
-263.78543480182566 75.78914908862754
-265.2356728782321 77.99211093960542
-266.32947345368314 79.90114171328608
-268.6231895857856 82.4034517000421
-271.49645676905993 84.70681464861735
-274.4840016243963 86.75772783072829
-280.39378980817634 88.8411433637244
-293.2973715221537 90.6133080735406
-313.3265371206024 91.78308508664401
-334.62373964125646 92.3143211031459
-356.06935472302996 92.51770028008372
-377.5476205682499 92.64895095231742
-399.034791167137 92.7605302141773
-420.53086651969113 92.85243806566334
-442.0803703942484 92.82631745490629
-463.62987426880574 92.80019684414926
-485.17937814336295 92.77407623339221
-506.7051360081411 92.80041271696543
-528.213084365585 92.86609202128633
-549.753683486475 92.85964282090313
-571.2705365975858 92.9056507148502
-592.7962944623641 92.9319871984234
-614.3309570808094 92.93865227162277
-635.8626514480322 92.95187448161343
-657.4121553225896 92.92575387085638
-679.009151216705 92.79471907143885
-700.5586550912622 92.7685984606818
-722.0695716999285 92.82772062821142
-743.5982978159291 92.84749997499335
-765.1270239319294 92.86727932177529
-786.6765278064868 92.84115871101825
-808.2586824444902 92.74290959555711
-829.9417576240553 92.4217178291924
-851.8385468916322 91.62841221385543
-873.1535589196205 92.12030540960964
-894.4745074500538 92.59908433178127
+250.58364278170546 0.02010118609808302
+252.49697751965863 0.06434059596684008
+252.6188737031914  0.03857934149112495
+252.7467558600228  0.09342545080711972
+253.91402065322796 0.11954353855061981
+254.24052828769095 0.1555840448928889
+252.60799011537603 0.13974426906972255
+254.5343851587076  0.1923458362821991
+252.934497749839   0.1757847754119919
+254.769470655521   0.23040594075618287
+253.26100538430205 0.211825281754261
+255.0437370684699  0.26760050317371764
+253.4569099649798  0.25075092828469394
+255.0159839195406  0.30281628091384547
+253.65281454565763 0.28967657481512703
+255.31800348141883 0.3393977510413956
+255.0894481372947  0.32282006796434274
+255.84041569655966 0.37111054710141886
+255.61186035243554 0.3545328640243662
+256.7056609278865  0.4060631893706818
+256.1342725675763  0.3862456600843896
+257.0680844021404  0.4391476143205719
+255.67716187932814 0.4179703291493025
+257.63620768610605 0.469850611314738
+258.3953379362325  0.4984967586243483
+258.7463336432802  0.53183363334070286
+257.3750015785357  0.5102235771412088
+259.50546389340667 0.5604797806503131
+259.8760500585222  0.5933838843384431
+258.4851275357098  0.57220659916717366
+260.47682410593404 0.6233655962855681
+261.1167790694815  0.6524817661762441
+261.3828827915689  0.6812059784930032
+262.1909891868648  0.7066075303914181
+263.33703098382983 0.7331944534154948
+263.78543480182566 0.7578914908862754
+265.2356728782321  0.7799211093960542
+266.32947345368314 0.7990114171328608
+268.6231895857856  0.824034517000421
+271.49645676905993 0.8470681464861735
+274.4840016243963  0.8675772783072829
+280.39378980817634 0.888411433637244
+293.2973715221537  0.906133080735406
+313.3265371206024  0.9178308508664401
+334.62373964125646 0.923143211031459
+356.06935472302996 0.9251770028008372
+377.5476205682499  0.9264895095231742
+399.034791167137   0.927605302141773
+420.53086651969113 0.9285243806566334
+442.0803703942484  0.9282631745490629
+463.62987426880574 0.9280019684414926
+485.17937814336295 0.9277407623339221
+506.7051360081411  0.9280041271696543
+528.213084365585   0.9286609202128633
+549.753683486475   0.9285964282090313
+571.2705365975858  0.929056507148502
+592.7962944623641  0.929319871984234
+614.3309570808094  0.9293865227162277
+635.8626514480322  0.9295187448161343
+657.4121553225896  0.9292575387085638
+679.009151216705   0.9279471907143885
+700.5586550912622  0.927685984606818
+722.0695716999285  0.9282772062821142
+743.5982978159291  0.9284749997499335
+765.1270239319294  0.9286727932177529
+786.6765278064868  0.9284115871101825
+808.2586824444902  0.9274290959555711
+829.9417576240553  0.924217178291924
+851.8385468916322  0.9162841221385543
+873.1535589196205  0.9212030540960964
+894.4745074500538  0.9259908433178127