Index: trunk/www/dch/download.php
===================================================================
--- trunk/www/dch/download.php	(revision 19097)
+++ trunk/www/dch/download.php	(revision 19733)
@@ -20,16 +20,17 @@
 }
 $maintenance=0;
-//$maintenance=1;
+$maintenance=1;
 
 if ($maintenance)
 {
     echo "<hr>\n <p style='font-size:xx-large'> MAINTENANCE ONGOING </p>\n";
-    echo "<p>check again in a few hours...</p>\n<p>\n<hr>\n<p>\n<p>\n";
+    echo "<p>check again later...</p>\n<p>\n<hr>\n<p>\n<p>\n";
 }
 
 
 $tables=array(
-      "AnalysisResultsRunLP"   => "QLA",
-      "AnalysisResultsRunISDC" => "ISDC",
+      "AnalysisResultsRunLP"     => "QLA",
+      "AnalysisResultsRunISDC"   => "ISDC",
+      "AnalysisResultsRunCutsLC" => "CutsLC",
       );
 
@@ -65,4 +66,9 @@
       );
 
+$rmemptyrows=array(
+      "no"    => "all data",
+      "yes"   => "remove rows with empty columns",
+      );
+
 $dusts=array(
       "all"  => "all data",
@@ -70,4 +76,17 @@
       "10"    => "dust<10",
       "1.0"   => "dust<1",
+      );
+
+$factorcuts=array(
+      "all"   => "all data",
+      "0.1"   => "zdfactor * thfactor > 0.1",
+      "0.2"   => "zdfactor * thfactor > 0.2",
+      "0.3"   => "zdfactor * thfactor > 0.3",
+      "0.4"   => "zdfactor * thfactor > 0.4",
+      "0.5"   => "zdfactor * thfactor > 0.5",
+      "0.6"   => "zdfactor * thfactor > 0.6",
+      "0.7"   => "zdfactor * thfactor > 0.7",
+      "0.8"   => "zdfactor * thfactor > 0.8",
+      "0.9"   => "zdfactor * thfactor > 0.9",
       );
 
@@ -152,8 +171,18 @@
     $time="novalue";
 
+if (!empty($_POST["factorcut"]))
+    $factorcut=$_POST["factorcut"];
+else
+    $factorcut="novalue";
+
 if (!empty($_POST["table"]))
     $table=$_POST["table"];
 else
     $table="AnalysisResultsRunLP";
+
+if (!empty($_POST["rmemptyrow"]))
+    $rmemptyrow=$_POST["rmemptyrow"];
+else
+    $rmemptyrow="no";
 
 if (!empty($_POST["th"]))
@@ -248,5 +277,6 @@
     print_popup("Please provide an email address.");
 
-if (empty($_POST["emailcopy"]))
+
+if (strpos($email, "@")!= false && empty($_POST["emailcopy"]))
     print_popup("Please agree that a copy of the email is stored.");
 
@@ -258,6 +288,6 @@
     print_popup("Email with data sent to ".$email);
     if ($maintenance)
-        echo $start." ".$stop." ".$source." ".$timebin." ".$email." ".$table." ".$time." ".$expert." ".$dch." ".$zd." ".$th." ".$light." ".$dust."<br>\n";
-    $sent=shell_exec("/users/fact/SW.automatic.processing/DataCheck/Tools/get_data.sh ".$start." ".$stop." ".$source." ".$timebin." ".$email." ".$table." ".$time." ".$expert." ".$dch." ".$zd." ".$th." ".$light." ".$dust);
+        echo $start." ".$stop." ".$source." ".$timebin." ".$email." ".$table." ".$time." ".$expert." ".$dch." ".$zd." ".$th." ".$light." ".$dust." ".$rmemptyrow." ".$factorcut."<br>\n";
+    $sent=shell_exec("/users/fact/SW.automatic.processing/DataCheck/Tools/get_data.sh ".$start." ".$stop." ".$source." ".$timebin." ".$email." ".$table." ".$time." ".$expert." ".$dch." ".$zd." ".$th." ".$light." ".$dust." ".$rmemptyrow." ".$factorcut);
     echo $sent;
     if (!empty($_POST["newsletter"]))
@@ -431,4 +461,28 @@
             printf("<option value='%s'>%s</option>\n", $key, $name);
     }
+    echo "</select>\n";
+
+    echo "<select name='factorcut' size='1'>\n";
+    if ($factorcut == "novalue")
+        printf("<option value='novalue' selected>Select Factor-Cut</option>\n");
+    else
+        printf("<option value='novalue'>Select Factor-Cut</option>\n");
+    foreach ($factorcuts as $key => $name)
+    {
+        if ($factorcut == $key)
+            printf("<option value='%s' selected>%s</option>\n", $key, $name);
+        else
+            printf("<option value='%s'>%s</option>\n", $key, $name);
+    }
+    echo "</select>\n";
+
+    echo "<select name='rmemptyrows' size='1'>\n";
+    foreach ($rmemptyrows as $key => $name)
+    {
+        if ($rmemptyrow == $key)
+            printf("<option value='%s' selected>%s</option>\n", $key, $name);
+        else
+            printf("<option value='%s'>%s</option>\n", $key, $name);
+    }
     echo "</select>\n <br>\n";
 }
@@ -466,6 +520,11 @@
     echo "<ul>\n";
     echo "<li>The correction formula to correct the excess rate for the effects of zd and threshold is not yet final.</li>\n";
-    echo "<li>The CU conversion is currently only valid for QLA and until summer 2016.</li>\n";
-    echo "<li>The data quality selection based on the artificial trigger rate R750 might not work for all data (effect of lidar).</li>\n";
+    //echo "<li>The CU conversion is currently only valid for QLA and until summer 2016.</li>\n";
+    echo "<li>The data quality selection based on the artificial trigger rate R750 \n";
+    echo "<ul>\n";
+    echo "<li>might not work for all data (effect of lidar).</li>\n";
+    echo "<li>might not be available for the newest data (reference value needs to be determined).</li>\n";
+    echo "</ul></li>\n";
+    echo "<li>Not for all data dust measurements are available.</li>\n";
     //echo "<li></li>\n";
     echo "</ul>";