Index: trunk/Mars/resmc/hawcseye/angular_acceptance_cone.txt
===================================================================
--- trunk/Mars/resmc/hawcseye/angular_acceptance_cone.txt	(revision 19891)
+++ trunk/Mars/resmc/hawcseye/angular_acceptance_cone.txt	(revision 19891)
@@ -0,0 +1,36 @@
+0.00000 0.99607 
+#2.00000 0.99589 
+#4.00000 0.99645 
+#6.00000 0.99640 
+8.00000 0.99612 
+#10.00000 0.99624 
+#12.00000 0.99580 
+#14.00000 0.99502 
+16.00000 0.99404 
+#18.00000 0.99206 
+#20.00000 0.98889 
+22.00000 0.98447 
+#24.00000 0.97762 
+26.00000 0.96714 
+#28.00000 0.95078 
+30.00000 0.92243 
+#32.00000 0.87233 
+34.00000 0.79709 
+#36.00000 0.71242 
+#38.00000 0.60222 
+40.00000 0.46846 
+#42.00000 0.35338 
+44.00000 0.26549 
+#46.00000 0.18617 
+48.00000 0.11790 
+#50.00000 0.06552 
+52.00000 0.03547 
+#54.00000 0.01744 
+#56.00000 0.00763 
+58.00000 0.00347 
+#60.00000 0.00179 
+#62.00000 0.00087 
+64.00000 0.00036 
+#66.00000 0.00015 
+#68.00000 0.00008 
+70.00000 0.00003 
Index: trunk/Mars/resmc/hawcseye/ceres.rc
===================================================================
--- trunk/Mars/resmc/hawcseye/ceres.rc	(revision 19890)
+++ trunk/Mars/resmc/hawcseye/ceres.rc	(revision 19891)
@@ -27,6 +27,6 @@
 # If you don't want it, it is written to the calibration output anyhow.
 # -------------------------------------------------------------------------
-#PathOut: .
-#PathIn: .
+#PathOut: ceres_output/
+#PathIn: ceres_input/
 
 
@@ -176,14 +176,18 @@
 
 #FIXME: This should be 2.5mm
-MirrorReflectivity.FileName:           resmc/hawcseye/transmission-pmma-3mm.txt
+#MirrorReflectivity.FileName:           resmc/hawcseye/transmission-pmma-3mm.txt
+MirrorReflectivity.FileName:           resmc/hawcseye/transmittance_lens.txt
 
 #FIXME: This should be Hamamatsu/SensL
-PhotonDetectionEfficiency.FileName:    resmc/hawcseye/pde.txt
+#PhotonDetectionEfficiency.FileName:    resmc/hawcseye/pde.txt
+PhotonDetectionEfficiency.FileName:    resmc/hawcseye/pde_SensL.txt
 
 #FIXME: Calculate for our aluminium and PMMA cones (this is for FACT cones)
-ConesAngularAcceptance.FileName:       resmc/hawcseye/cones-angular-acceptance.txt
+#ConesAngularAcceptance.FileName:       resmc/hawcseye/cones-angular-acceptance.txt
+ConesAngularAcceptance.FileName:       resmc/hawcseye/angular_acceptance_cone.txt
 
 #FIXME: Calculate for out cones
-ConesTransmission.FileName:            resmc/fact/Transmittance_1439Cones_FACT_bearbeitet.txt
+#ConesTransmission.FileName:            resmc/fact/Transmittance_1439Cones_FACT_bearbeitet.txt
+ConesTransmission.FileName:            resmc/hawcseye/transmittance_cone.txt
 
 # Skipped otherwise due to CEFFIC option
Index: trunk/Mars/resmc/hawcseye/pde_SensL.txt
===================================================================
--- trunk/Mars/resmc/hawcseye/pde_SensL.txt	(revision 19891)
+++ trunk/Mars/resmc/hawcseye/pde_SensL.txt	(revision 19891)
@@ -0,0 +1,47 @@
+# several points are outcomment, for a faster calculation of the spline
+251.00000 0.00000 
+#256.00000 0.00000 
+#261.00000 0.01462 
+#266.00000 0.04277 
+271.00000 0.07092 
+276.00000 0.09908 
+#281.00000 0.12723 
+286.00000 0.15538 
+#291.00000 0.18353 
+296.00000 0.21168 
+#301.00000 0.24045 
+306.00000 0.26171 
+311.00000 0.28067 
+331.00000 0.33571 
+351.00000 0.36432 
+371.00000 0.39341 
+391.00000 0.44455 
+411.00000 0.47711 
+431.00000 0.48329 
+451.00000 0.46166 
+#471.00000 0.42722 
+491.00000 0.38433 
+#511.00000 0.33897 
+531.00000 0.29770 
+#551.00000 0.26145 
+571.00000 0.23117 
+#591.00000 0.20404 
+#611.00000 0.17972 
+#631.00000 0.15792 
+651.00000 0.13839 
+#671.00000 0.12088 
+#691.00000 0.10519 
+#711.00000 0.09113 
+731.00000 0.07852 
+#751.00000 0.06723 
+771.00000 0.05710 
+#791.00000 0.04803 
+#811.00000 0.03990 
+#831.00000 0.03261 
+851.00000 0.02608 
+#871.00000 0.02023 
+891.00000 0.01498 
+#911.00000 0.01028 
+931.00000 0.00607 
+951.00000 0.00229 
+#971.00000 0.00000 
Index: trunk/Mars/resmc/hawcseye/transmittance_cone.txt
===================================================================
--- trunk/Mars/resmc/hawcseye/transmittance_cone.txt	(revision 19891)
+++ trunk/Mars/resmc/hawcseye/transmittance_cone.txt	(revision 19891)
@@ -0,0 +1,77 @@
+# several points are outcomment, for a faster calculation of the spline
+242.88000 0.00001
+252.88000 0.00001 
+262.88000 0.00003
+272.88000 0.00002 
+282.88000 0.00010 
+292.88000 0.00214 
+302.88000 0.07241 
+312.88000 0.23206 
+#322.88000 0.39306 
+332.88000 0.54079 
+#342.88000 0.67379 
+352.88000 0.76083 
+#362.88000 0.81558 
+372.88000 0.84227 
+#382.88000 0.86202 
+392.88000 0.87671 
+402.88000 0.88561 
+#412.88000 0.89029 
+#422.88000 0.89475 
+#432.88000 0.89837 
+442.88000 0.90080 
+#452.88000 0.90209 
+#462.88000 0.90290 
+#472.88000 0.90371 
+482.88000 0.90362 
+#492.88000 0.90349 
+#502.88000 0.90338 
+#512.88000 0.90344 
+522.88000 0.90410 
+#532.88000 0.90477 
+#542.88000 0.90544 
+#552.88000 0.90584 
+562.88000 0.90613 
+#572.88000 0.90638 
+#582.88000 0.90653 
+#592.88000 0.90668 
+602.88000 0.90683 
+#612.88000 0.90707 
+#622.88000 0.90781 
+632.88000 0.90854 
+#642.88000 0.90928 
+#652.88000 0.91002 
+#662.88000 0.90965 
+672.88000 0.90858 
+#682.88000 0.90765 
+#692.88000 0.90675 
+702.88000 0.90651 
+#712.88000 0.90647 
+#722.88000 0.90643 
+732.88000 0.90650 
+#742.88000 0.90671 
+#752.88000 0.90693 
+#762.88000 0.90714 
+772.88000 0.90717 
+#782.88000 0.90714 
+#792.88000 0.90711 
+#802.88000 0.90700 
+812.88000 0.90672 
+822.88000 0.90645 
+#832.88000 0.90617 
+842.88000 0.90665 
+852.88000 0.91267 
+#862.88000 0.91177 
+872.88000 0.90987 
+#882.88000 0.90441 
+892.88000 0.89898 
+#902.88000 0.90080 
+912.88000 0.90572 
+#922.88000 0.91078 
+932.88000 0.91292 
+#942.88000 0.91294 
+#952.88000 0.91297 
+#962.88000 0.91171 
+972.88000 0.90957 
+#982.88000 0.90721 
+992.88000 0.90615 
Index: trunk/Mars/resmc/hawcseye/transmittance_lens.txt
===================================================================
--- trunk/Mars/resmc/hawcseye/transmittance_lens.txt	(revision 19891)
+++ trunk/Mars/resmc/hawcseye/transmittance_lens.txt	(revision 19891)
@@ -0,0 +1,80 @@
+# several points are outcomment, for a faster calculation of the spline
+#209.88000 0.00001 
+219.88000 0.00001 
+229.88000 0.00004
+239.88000 0.00008 
+249.88000 0.00217 
+259.88000 0.07344 
+269.88000 0.23536 
+279.88000 0.39864 
+289.88000 0.54847 
+#299.88000 0.68336 
+309.88000 0.77163 
+#319.88000 0.82716 
+329.88000 0.85423 
+#339.88000 0.87426 
+349.88000 0.88916 
+#359.88000 0.89818 
+#369.88000 0.90293 
+379.88000 0.90746 
+#389.88000 0.91113 
+#399.88000 0.91359 
+409.88000 0.91406 
+#419.88000 0.91384 
+#429.88000 0.91364 
+439.88000 0.91385 
+#449.88000 0.91465 
+#459.88000 0.91547 
+#469.88000 0.91630 
+479.88000 0.91649 
+#489.88000 0.91636 
+#499.88000 0.91624 
+#509.88000 0.91613 
+519.88000 0.91674 
+#529.88000 0.91741 
+#539.88000 0.91809 
+#549.88000 0.91862 
+559.88000 0.91891 
+#569.88000 0.91920 
+#579.88000 0.91935 
+#589.88000 0.91951 
+599.88000 0.91966 
+#609.88000 0.91982 
+#619.88000 0.92047 
+629.88000 0.92122 
+#639.88000 0.92197 
+#649.88000 0.92272 
+#659.88000 0.92289 
+669.88000 0.92180 
+#679.88000 0.92081 
+#689.88000 0.91989 
+699.88000 0.91939 
+#709.88000 0.91935 
+#719.88000 0.91932 
+729.88000 0.91930 
+#739.88000 0.91952 
+#749.88000 0.91974 
+#759.88000 0.91996 
+769.88000 0.92006 
+#779.88000 0.92003 
+#789.88000 0.92000 
+#799.88000 0.91997 
+809.88000 0.91968 
+819.88000 0.91940 
+#829.88000 0.91912 
+839.88000 0.91930 
+849.88000 0.92293 
+#859.88000 0.92549 
+869.88000 0.92436 
+#879.88000 0.91911 
+889.88000 0.91281 
+#899.88000 0.91303 
+909.88000 0.91655 
+#919.88000 0.92227 
+929.88000 0.92587 
+#939.88000 0.92590 
+#949.88000 0.92593 
+#959.88000 0.92516 
+969.88000 0.92320 
+#979.88000 0.92081 
+989.88000 0.91923 